#!/bin/sh

###### Command definitions #####
CMD_ECHO="/bin/echo"

CMD_RM="/bin/rm"

CMD_MV="/bin/mv"

CMD_SED="/bin/sed"

CMD_CAT="/bin/cat"
##### System definitions #####
QPKG_NAME="xCloud"
SMB_CONFIG_FILE="/volume0/usr/builtin/etc/samba/smb.conf"
INSTALL_PATH="/usr/local/AppCentral/xCloud"
XCLOUD_SHARE_CONFIG_FILE="$INSTALL_PATH/etc/.share.conf"
XCLOUD_SHARE_CONFIG_FILEI_TEMP="$INSTALL_PATH/etc/.share.conf.temp"
VOLUME="/volume1"
#for mount_path in `df -h| grep volume | awk '{print $6}'`
#do
#    /usr/syno/sbin/synoshare --enummnt $mount_path/xcloud | grep "0 Listed:" > /dev/null 2>&1
#    if [ $? -ne 0 ]
#    then
#        VOLUME=$mount_path
#    fi
#done
#share_path=$(/usr/syno/sbin/synoshare --get xcloud | grep Path | awk -F[ '{print $2}' | awk -F] '{print $1}')
VOLUME=/volume1/Public
if [ ! -d ${VOLUME}/xcloud ]
then
    mkdir -p ${VOLUME}/xcloud
fi
if [ ! -d ${VOLUME}/xcloud/music ]
then
    mkdir -p ${VOLUME}/xcloud/music
fi
if [ ! -d ${VOLUME}/xcloud/video ]
then
    mkdir -p ${VOLUME}/xcloud/video
fi
if [ ! -d ${VOLUME}/xcloud/docs ]
then
    mkdir -p ${VOLUME}/xcloud/docs
fi
if [ ! -d ${VOLUME}/xcloud/pic ]
then
    mkdir -p ${VOLUME}/xcloud/pic
fi
if [ ! -d ${VOLUME}/xcloud/pic/instant ]
then
    mkdir -p ${VOLUME}/xcloud/pic/instant
fi
if [ ! -d /volume1/Web/xCloud/source ]
then
    ln -s /volume1/Public/xcloud /volume1/Web/xCloud/source
fi
if [ -f "${SMB_CONFIG_FILE}" ]
then
	$CMD_ECHO "[DEFAULT]" > $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT = $VOLUME/xcloud" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT_PIC = $VOLUME/xcloud/pic" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT_INSTANT = $VOLUME/xcloud/pic/instant" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT_MUSIC = $VOLUME/xcloud/music" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT_VIDEO = $VOLUME/xcloud/video" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "DEFAULT_DOC = $VOLUME/xcloud/docs" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_ECHO "[SHARELIST]" >> $XCLOUD_SHARE_CONFIG_FILEI_TEMP
	$CMD_SED -n '/^\[.*\]$/p' "$SMB_CONFIG_FILE" | grep -v "\[global\]" | grep -v "\[home\]" > $INSTALL_PATH/etc/key.txt
	$CMD_SED -n '/path *= *\//p' "$SMB_CONFIG_FILE" | grep -v "\%U"| awk -F= '{print $2}' > $INSTALL_PATH/etc/path.txt
	i=1
	while read SECTION
	do
		SECTION_TEMP=`$CMD_ECHO "$SECTION" | awk -F[ '{print $2}' | awk -F] '{print $1}'`
		SHARE_PATH=`$CMD_SED -n "${i}p" $INSTALL_PATH/etc/path.txt`
		$CMD_ECHO "$SECTION_TEMP = $SHARE_PATH">>$XCLOUD_SHARE_CONFIG_FILEI_TEMP
		i=`expr $i + 1`
	done < $INSTALL_PATH/etc/key.txt
	$CMD_RM $INSTALL_PATH/etc/key.txt
	$CMD_RM $INSTALL_PATH/etc/path.txt
	$CMD_MV $XCLOUD_SHARE_CONFIG_FILEI_TEMP $XCLOUD_SHARE_CONFIG_FILE
	chmod 755 $XCLOUD_SHARE_CONFIG_FILE
else
	$CMD_ECHO "${SMB_CONFIG_FILE} is no exist!"
fi	
exit 0
